// StatusBar.h: interface for the CStatusBar class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_STATUSBAR_H__8FED202A_9209_4E8F_9125_6F960D617C08__INCLUDED_)
#define AFX_STATUSBAR_H__8FED202A_9209_4E8F_9125_6F960D617C08__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

//
// CLASS:   CStatusBar
//
// PURPOSE: Abstraction around the statusbar control. Currently, it
//          only gives you a way of controlling an already instantiated
//          status bar; i.e., no creation support.
class CStatusBar  
{
public:
    CStatusBar();
    CStatusBar(HWND hWndStatus, int cols);
	virtual ~CStatusBar();

    // The number of columns to split the statusbar up into.
    void SetColumns(int i);
    int GetColumns();

    // the width of each column is (widthStatusBar / noColumns); no
    // support for customizing the relief to use on individual columns.

    // Update the text to use for a particular column.
    void SetColumnText(int i, LPCTSTR szText);

    // the size of the parent window may have changed, adjust the
    // positioning & size of the sub-parts of the statusbar.
    void ResizeStatusBar();

private:
    HWND m_hWndStatusBar;
    int  m_noColumns;
};

#endif // !defined(AFX_STATUSBAR_H__8FED202A_9209_4E8F_9125_6F960D617C08__INCLUDED_)
